// DicksBackup.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDicksBackupApp

BEGIN_MESSAGE_MAP(CDicksBackupApp, CWinApp)
	//{{AFX_MSG_MAP(CDicksBackupApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_VIEW_OPEN_MRU, OnViewOpenMru)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OPEN_MRU, OnUpdateViewOpenMru)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDicksBackupApp construction

CDicksBackupApp::CDicksBackupApp()
{
	m_bOpenFirstMRU = FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDicksBackupApp object

CDicksBackupApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDicksBackupApp initialization

BOOL CDicksBackupApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(OSB);

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CDicksBackupDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CDicksBackupView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// was there a backup jop to open on the command line?
	m_bCommandLineFileToOpen = cmdInfo.m_nShellCommand == CCommandLineInfo::FileOpen ? TRUE : FALSE;

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// automaticallu open first MRU
	m_bOpenFirstMRU = GetProfileInt(settings, bOpenMRU, FALSE);

	if(m_bOpenFirstMRU && !m_bCommandLineFileToOpen && m_pRecentFileList != NULL && ::strlen((*m_pRecentFileList)[0]))
	{
		OpenDocumentFile((*m_pRecentFileList)[0]);
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CBitmapButton	m_emailButton;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnEmail();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_EMAIL_BTN, m_emailButton);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_SETCURSOR()
	ON_BN_CLICKED(IDC_EMAIL_BTN, OnEmail)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDicksBackupApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CAboutDlg::OnEmail() 
{
	CString url(MAIL2);
	url += MY_EMAIL_URL;
	url += SUBJECT;
	
	if((UINT)ShellExecute(NULL, _T("open"), url, NULL, NULL, SW_NORMAL) <= HINSTANCE_ERROR)
	{
		MessageBox("Problem sending mail.", "Send Dick Mail", MB_ICONERROR);
	}
	
	return;
}

BOOL CAboutDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// show hand cursor if over the email bitmap button
	if(pWnd == (CWnd *)GetDlgItem(IDC_EMAIL_BTN))
	{
		::SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_HAND));
   		return TRUE;
	}
	
	return CDialog::OnSetCursor(pWnd, nHitTest, message);
}

BOOL CAboutDlg::OnInitDialog() 
{
	m_emailButton.AutoLoad(IDC_EMAIL_BTN, this);

	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CDicksBackupApp message handlers

#include <afxadv.h> // definition for class CRecentFileList

// dragged files from explorer are added to backup list
CDocument* CDicksBackupApp::OpenDocumentFile(LPCTSTR lpszFileName)
{
	// open a command line backup manager
	if(m_bCommandLineFileToOpen)
	{
		m_bCommandLineFileToOpen = FALSE;
		// The first time we try to open it will fail since the Mainframe is not ready
		// It returns from serialize with no Mainframe avaliable
		CDicksBackupDoc * pDoc = (CDicksBackupDoc *)CWinApp::OpenDocumentFile(lpszFileName);
		ASSERT_VALID(pDoc);
		// second time Mainframe and View are alive, so try to open again
		pDoc->OnOpenDocument(lpszFileName);		

		CMainFrame * pFrame = (CMainFrame *)AfxGetMainWnd();
		ASSERT_VALID(pFrame);
		CDicksBackupView * pListView = (CDicksBackupView *)pFrame->GetActiveView();
		ASSERT_VALID(pListView);
		// display all the data
		pListView->OnInitialUpdate();

		return pDoc;
	}

	int nMRU = m_pRecentFileList->GetSize();
	// if it is a file in the MRU list, open it as a backup manager
	for(int i = 0; i < nMRU; i++)
	{
		if((*m_pRecentFileList)[i].CompareNoCase(lpszFileName) == 0)
		{
			return CWinApp::OpenDocumentFile(lpszFileName);
		}
	}

	// Otherwise, add file to current backup manager list
	CDicksBackupDoc * pDoc = (CDicksBackupDoc *)(((CFrameWnd *)AfxGetMainWnd())->GetActiveDocument());

	pDoc->AddFileToBackup(CString(lpszFileName));

	return NULL;
}

int CDicksBackupApp::ExitInstance() 
{
	WriteProfileInt(settings, bOpenMRU, m_bOpenFirstMRU);
	
	return CWinApp::ExitInstance();
}

void CDicksBackupApp::OnViewOpenMru() 
{
	m_bOpenFirstMRU = !m_bOpenFirstMRU;
}

void CDicksBackupApp::OnUpdateViewOpenMru(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bOpenFirstMRU);	
}
