// EnterStrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyStuff.h"
#include "DicksBackup.h"
#include "EnterStrDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEnterStrDlg dialog


CEnterStrDlg::CEnterStrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEnterStrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEnterStrDlg)
	m_editStr = _T("");
	//}}AFX_DATA_INIT
	m_captionStr = _T("");
	m_addStyles = 0;
	m_bShowBrowseButton = FALSE;
}

void CEnterStrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnterStrDlg)
	DDX_Text(pDX, IDC_EDIT_STRING, m_editStr);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnterStrDlg, CDialog)
	//{{AFX_MSG_MAP(CEnterStrDlg)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_DIR, OnButtonBrowseDir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnterStrDlg message handlers

BOOL CEnterStrDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CEdit * pEdit = (CEdit *)GetDlgItem(IDC_EDIT_STRING);
	pEdit->ModifyStyle(0, m_addStyles);

	SetWindowText(m_captionStr);

	// hide the directory browse button and widen edit window
	if(m_bShowBrowseButton == FALSE)
	{
		CButton * pButton = (CButton *)GetDlgItem(IDC_BUTTON_BROWSE_DIR);
		pButton->ShowWindow(SW_HIDE); 
		CRect buttonRect;
		pButton->GetWindowRect(&buttonRect);
		ScreenToClient(&buttonRect);

		CRect editRect;
		pEdit->GetWindowRect(&editRect);
		ScreenToClient(&editRect);

		pEdit->MoveWindow(editRect.left, editRect.top, 
			              buttonRect.right - editRect.left, editRect.Height(), TRUE); 
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEnterStrDlg::OnButtonBrowseDir() 
{
	UpdateData(TRUE);
	CString dirStr = m_editStr.Left(m_editStr.ReverseFind(_T('\\')));
	// returns directory without trailing slash
	if(BrowseFolders(m_hWnd, dirStr.GetBuffer(_MAX_PATH) ,_T("Choose New Archive Folder")))
	{
		dirStr.ReleaseBuffer();

		if(dirStr.GetLength() > 0 && dirStr[dirStr.GetLength() - 1] != _T('\\'))
		{
			dirStr += _T('\\');
		}

		m_editStr = dirStr + m_editStr.Mid(m_editStr.ReverseFind(_T('\\')) + 1);
		UpdateData(FALSE);
	}
}
